stages:
  - build
  - linter
  - sonar_cloud

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

build:
  stage: build
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw package
  artifacts:
    paths:
      - target/main-0.0.1-SNAPSHOT.jar

linter:
  stage: linter
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw spotbugs:spotbugs
  dependencies:
    - build

sonar_cloud:
  stage: sonar_cloud
  image: maven
  allow_failure: true
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - mvn verify sonar:sonar -Dsonar.projectKey=ivan-sqr_s23-lab2-linter-and-sonar-as-a-part-of-qg-ivan
  only:
    - merge_requests
    - master
    - develop
  dependencies:
    - build
    - linter
